/**
 * Generated by Apache Royale Compiler from org/apache/royale/file/beads/FileBrowser.as
 * org.apache.royale.file.beads.FileBrowser
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.file.beads.FileBrowser');

goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.core.WrappedHTMLElement');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.file.FileProxy');
goog.require('org.apache.royale.file.IFileModel');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 *  Constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.file.beads.FileBrowser = function() {
  this.createDelegate();
};


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser__strand;


/**
 * @protected
 * @type {org.apache.royale.core.WrappedHTMLElement}
 */
org.apache.royale.file.beads.FileBrowser.prototype.delegate;


/**
 * @royaleignorecoercion org.apache.royale.core.WrappedHTMLElement
 */
org.apache.royale.file.beads.FileBrowser.prototype.createDelegate = function() {
  this.delegate = document.createElement('input');
  this.delegate.setAttribute('type', 'file');
  goog.events.listen(this.delegate, 'change', org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_fileChangeHandler, this, 'org_apache_royale_file_beads_FileBrowser_fileChangeHandler'));
};


/**
 * @private
 * @type {Object}
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_focusedButton;


/**
 * @private
 * @type {number}
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_interval = -1;


/**
 *  Open up the system file browser. A user selection will trigger a 'modelChanged' event on the strand.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9
 *  @royaleignorecoercion org.apache.royale.core.WrappedHTMLElement
 */
org.apache.royale.file.beads.FileBrowser.prototype.browse = function() {
  
  this.org_apache_royale_file_beads_FileBrowser_focusedButton = document.activeElement;
  this.org_apache_royale_file_beads_FileBrowser_focusedButton.addEventListener("blur", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_blurHandler, this, 'org_apache_royale_file_beads_FileBrowser_blurHandler'));
  this.org_apache_royale_file_beads_FileBrowser_focusedButton.addEventListener("focus", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_focusHandler, this, 'org_apache_royale_file_beads_FileBrowser_focusHandler'));
  window.addEventListener("keydown", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_keyHandler, this, 'org_apache_royale_file_beads_FileBrowser_keyHandler'));
  window.addEventListener("mousemove", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_mouseHandler, this, 'org_apache_royale_file_beads_FileBrowser_mouseHandler'));
  window.addEventListener("mousedown", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_mouseHandler, this, 'org_apache_royale_file_beads_FileBrowser_mouseHandler'));
  this.delegate.click();
};


/**
 * @private
 * @param {Object} e
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_blurHandler = function(e) {
  this.org_apache_royale_file_beads_FileBrowser_cleanupWindow();
};


/**
 * @nocollapse
 * @const
 * @type {number}
 */
org.apache.royale.file.beads.FileBrowser.CANCEL_TIMEOUT = 150;


/**
 * @private
 * @param {Object} e
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_focusHandler = function(e) {
  this.org_apache_royale_file_beads_FileBrowser_cleanup();
  setTimeout(org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_maybeCancel, this, 'org_apache_royale_file_beads_FileBrowser_maybeCancel'), org.apache.royale.file.beads.FileBrowser.CANCEL_TIMEOUT);
};


/**
 * @private
 * @param {Object} e
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_keyHandler = function(e) {
  this.org_apache_royale_file_beads_FileBrowser_cleanup();
  setTimeout(org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_maybeCancel, this, 'org_apache_royale_file_beads_FileBrowser_maybeCancel'), org.apache.royale.file.beads.FileBrowser.CANCEL_TIMEOUT);
};


/**
 * @private
 * @param {Object} e
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_mouseHandler = function(e) {
  this.org_apache_royale_file_beads_FileBrowser_cleanup();
  setTimeout(org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_maybeCancel, this, 'org_apache_royale_file_beads_FileBrowser_maybeCancel'), org.apache.royale.file.beads.FileBrowser.CANCEL_TIMEOUT);
};


/**
 * @private
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_cleanupWindow = function() {
  window.removeEventListener("keydown", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_keyHandler, this, 'org_apache_royale_file_beads_FileBrowser_keyHandler'));
  window.removeEventListener("mousemove", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_mouseHandler, this, 'org_apache_royale_file_beads_FileBrowser_mouseHandler'));
  window.removeEventListener("mousedown", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_mouseHandler, this, 'org_apache_royale_file_beads_FileBrowser_mouseHandler'));
};


/**
 * @private
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_cleanup = function() {
  this.org_apache_royale_file_beads_FileBrowser_focusedButton.removeEventListener("focus", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_focusHandler, this, 'org_apache_royale_file_beads_FileBrowser_focusHandler'));
  this.org_apache_royale_file_beads_FileBrowser_focusedButton.removeEventListener("blur", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_blurHandler, this, 'org_apache_royale_file_beads_FileBrowser_blurHandler'));
  window.removeEventListener("keydown", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_keyHandler, this, 'org_apache_royale_file_beads_FileBrowser_keyHandler'));
  window.removeEventListener("mousemove", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_mouseHandler, this, 'org_apache_royale_file_beads_FileBrowser_mouseHandler'));
  window.removeEventListener("mousedown", org.apache.royale.utils.Language.closure(this.org_apache_royale_file_beads_FileBrowser_mouseHandler, this, 'org_apache_royale_file_beads_FileBrowser_mouseHandler'));
};


/**
 * @private
 * @type {number}
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_frameCount = 0;


/**
 *  @royaleignorecoercion HTMLInputElement
 * @private
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_maybeCancel = function() {
  if (this.delegate.files.length) {
  } else {
    this.org_apache_royale_file_beads_FileBrowser_host.dispatchEvent(new org.apache.royale.events.Event("cancel"));
  }
};


/**
 *  @asprivate
 *  @royaleignorecoercion HTMLInputElement
 *  @royaleignorecoercion org.apache.royale.file.IFileModel
 * @private
 * @param {org.apache.royale.events.Event} e
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_fileChangeHandler = function(e) {
  var /** @type {Object} */ fileModel = this.org_apache_royale_file_beads_FileBrowser_host.model;
  fileModel.fileReference = this.delegate.files[0];
  this.org_apache_royale_file_beads_FileBrowser_host.dispatchEvent(new org.apache.royale.events.Event("modelChanged"));
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.file.beads.FileBrowser.prototype.strand;


org.apache.royale.file.beads.FileBrowser.prototype.set__strand = function(value) {
  this.org_apache_royale_file_beads_FileBrowser__strand = value;
};


/**
 * @type {org.apache.royale.file.FileProxy}
 */
org.apache.royale.file.beads.FileBrowser.prototype.org_apache_royale_file_beads_FileBrowser_host;


org.apache.royale.file.beads.FileBrowser.prototype.get__org_apache_royale_file_beads_FileBrowser_host = function() {
  return this.org_apache_royale_file_beads_FileBrowser__strand;
};


Object.defineProperties(org.apache.royale.file.beads.FileBrowser.prototype, /** @lends {org.apache.royale.file.beads.FileBrowser.prototype} */ {
/**
 * @type {org.apache.royale.core.IStrand}
 */
strand: {
set: org.apache.royale.file.beads.FileBrowser.prototype.set__strand},
/**
 * @type {org.apache.royale.file.FileProxy}
 */
org_apache_royale_file_beads_FileBrowser_host: {
get: org.apache.royale.file.beads.FileBrowser.prototype.get__org_apache_royale_file_beads_FileBrowser_host}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.file.beads.FileBrowser.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'FileBrowser', qName: 'org.apache.royale.file.beads.FileBrowser', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.file.beads.FileBrowser.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.file.beads.FileBrowser'}
      };
    },
    methods: function () {
      return {
        'FileBrowser': { type: '', declaredBy: 'org.apache.royale.file.beads.FileBrowser'},
        'createDelegate': { type: 'void', declaredBy: 'org.apache.royale.file.beads.FileBrowser'},
        'browse': { type: 'void', declaredBy: 'org.apache.royale.file.beads.FileBrowser'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.file.beads.FileBrowser.prototype.ROYALE_COMPILE_FLAGS = 10;