/**
 * Generated by Apache Royale Compiler from org/apache/royale/file/beads/FileUploader.as
 * org.apache.royale.file.beads.FileUploader
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.file.beads.FileUploader');

goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.file.FileProxy');
goog.require('org.apache.royale.file.IFileModel');
goog.require('org.apache.royale.net.URLBinaryLoader');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.file.beads.FileUploader = function() {
};


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.file.beads.FileUploader.prototype.org_apache_royale_file_beads_FileUploader__strand;


/**
 * @private
 * @type {string}
 */
org.apache.royale.file.beads.FileUploader.prototype.org_apache_royale_file_beads_FileUploader__contentType;


/**
 *  Upload a file to the specified url.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9
 *  @royaleignorecoercion org.apache.royale.file.IFileModel
 * @param {string} url
 */
org.apache.royale.file.beads.FileUploader.prototype.upload = function(url) {
  var /** @type {org.apache.royale.net.URLBinaryLoader} */ binaryUploader = new org.apache.royale.net.URLBinaryLoader();
  var /** @type {org.apache.royale.net.URLRequest} */ req = new org.apache.royale.net.URLRequest();
  req.contentType = this.contentType;
  req.method = "POST";
  req.data = this.host.model.blob;
  req.url = url;
  binaryUploader.addEventListener(org.apache.royale.events.Event.COMPLETE, org.apache.royale.utils.Language.closure(this.completeHandler, this, 'completeHandler'));
  binaryUploader.load(req);
};


/**
 */
org.apache.royale.file.beads.FileUploader.prototype.cancel = function() {
};


/**
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.file.beads.FileUploader.prototype.completeHandler = function(event) {
  org.apache.royale.utils.Language.as(event.target, org.apache.royale.events.IEventDispatcher).removeEventListener(org.apache.royale.events.Event.COMPLETE, org.apache.royale.utils.Language.closure(this.completeHandler, this, 'completeHandler'));
  org.apache.royale.utils.Language.as(this.host, org.apache.royale.events.IEventDispatcher).dispatchEvent(event);
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.file.beads.FileUploader.prototype.strand;


org.apache.royale.file.beads.FileUploader.prototype.set__strand = function(value) {
  this.org_apache_royale_file_beads_FileUploader__strand = value;
};


/**
 * @nocollapse
 * @type {org.apache.royale.file.FileProxy}
 */
org.apache.royale.file.beads.FileUploader.prototype.host;


org.apache.royale.file.beads.FileUploader.prototype.get__host = function() {
  return this.org_apache_royale_file_beads_FileUploader__strand;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
org.apache.royale.file.beads.FileUploader.prototype.contentType;


org.apache.royale.file.beads.FileUploader.prototype.get__contentType = function() {
  return this.org_apache_royale_file_beads_FileUploader__contentType;
};


org.apache.royale.file.beads.FileUploader.prototype.set__contentType = function(value) {
  this.org_apache_royale_file_beads_FileUploader__contentType = value;
};


Object.defineProperties(org.apache.royale.file.beads.FileUploader.prototype, /** @lends {org.apache.royale.file.beads.FileUploader.prototype} */ {
/**
 * @type {org.apache.royale.core.IStrand}
 */
strand: {
set: org.apache.royale.file.beads.FileUploader.prototype.set__strand},
/**
 * @type {org.apache.royale.file.FileProxy}
 */
host: {
get: org.apache.royale.file.beads.FileUploader.prototype.get__host},
/**
 * @type {string}
 */
contentType: {
get: org.apache.royale.file.beads.FileUploader.prototype.get__contentType,
set: org.apache.royale.file.beads.FileUploader.prototype.set__contentType}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.file.beads.FileUploader.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'FileUploader', qName: 'org.apache.royale.file.beads.FileUploader', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.file.beads.FileUploader.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.file.beads.FileUploader'},
        'contentType': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.file.beads.FileUploader'}
      };
    },
    methods: function () {
      return {
        'upload': { type: 'void', declaredBy: 'org.apache.royale.file.beads.FileUploader', parameters: function () { return [ 'String', false ]; }},
        'cancel': { type: 'void', declaredBy: 'org.apache.royale.file.beads.FileUploader'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.file.beads.FileUploader.prototype.ROYALE_COMPILE_FLAGS = 10;