/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/URLBinaryLoader.as
 * org.apache.royale.net.URLBinaryLoader
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.URLBinaryLoader');

goog.require('org.apache.royale.events.DetailEvent');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.ProgressEvent');
goog.require('org.apache.royale.net.URLLoaderBase');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.net.URLStream');
goog.require('org.apache.royale.utils.BinaryData');
goog.require('org.apache.royale.utils.Endian');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.net.URLLoaderBase}
 */
org.apache.royale.net.URLBinaryLoader = function() {
  
  this.org_apache_royale_net_URLBinaryLoader__endian = org.apache.royale.utils.Endian.BIG_ENDIAN;
  org.apache.royale.net.URLBinaryLoader.base(this, 'constructor');
  this.createStream();
};
goog.inherits(org.apache.royale.net.URLBinaryLoader, org.apache.royale.net.URLLoaderBase);


/**
 * @type {org.apache.royale.utils.BinaryData}
 */
org.apache.royale.net.URLBinaryLoader.prototype.data;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.URLBinaryLoader.prototype.org_apache_royale_net_URLBinaryLoader__endian;


/**
 * @protected
 * @type {org.apache.royale.net.URLStream}
 */
org.apache.royale.net.URLBinaryLoader.prototype.stream;


/**
 * @type {number}
 */
org.apache.royale.net.URLBinaryLoader.prototype.bytesLoaded = 0;


/**
 * @type {number}
 */
org.apache.royale.net.URLBinaryLoader.prototype.bytesTotal = 0;


/**
 * @protected
 */
org.apache.royale.net.URLBinaryLoader.prototype.createStream = function() {
  this.stream = new org.apache.royale.net.URLStream();
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.org_apache_royale_net_URLBinaryLoader_progressFunction = function(stream) {
  this.bytesLoaded = stream.bytesLoaded;
  this.bytesTotal = stream.bytesTotal;
  this.dispatchEvent(new org.apache.royale.events.ProgressEvent("progress", false, false, this.bytesLoaded, this.bytesTotal));
  if (this.onProgress)
    this.onProgress(this);
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.org_apache_royale_net_URLBinaryLoader_statusFunction = function(stream) {
  this.requestStatus = stream.requestStatus;
  this.dispatchEvent(new org.apache.royale.events.DetailEvent("httpStatus", false, false, "" + this.requestStatus));
  if (this.onStatus)
    this.onStatus(this);
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.org_apache_royale_net_URLBinaryLoader_errorFunction = function(stream) {
  this.data = stream.response;
  this.dispatchEvent(new org.apache.royale.events.DetailEvent("communicationError", false, false, "" + this.requestStatus));
  if (this.onError)
    this.onError(this);
  this.cleanupCallbacks();
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.org_apache_royale_net_URLBinaryLoader_completeFunction = function(stream) {
  this.data = stream.response;
  this.dispatchEvent(new org.apache.royale.events.Event("complete"));
  if (this.onComplete)
    this.onComplete(this);
  this.cleanupCallbacks();
};


/**
 * @protected
 */
org.apache.royale.net.URLBinaryLoader.prototype.setupCallbacks = function() {
  this.stream.onProgress = org.apache.royale.utils.Language.closure(this.org_apache_royale_net_URLBinaryLoader_progressFunction, this, 'org_apache_royale_net_URLBinaryLoader_progressFunction');
  this.stream.onStatus = org.apache.royale.utils.Language.closure(this.org_apache_royale_net_URLBinaryLoader_statusFunction, this, 'org_apache_royale_net_URLBinaryLoader_statusFunction');
  this.stream.onError = org.apache.royale.utils.Language.closure(this.org_apache_royale_net_URLBinaryLoader_errorFunction, this, 'org_apache_royale_net_URLBinaryLoader_errorFunction');
  this.stream.onComplete = org.apache.royale.utils.Language.closure(this.org_apache_royale_net_URLBinaryLoader_completeFunction, this, 'org_apache_royale_net_URLBinaryLoader_completeFunction');
};


/**
 *  Makes the URL request.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.7.0
 * @param {org.apache.royale.net.URLRequest} request
 */
org.apache.royale.net.URLBinaryLoader.prototype.load = function(request) {
  this.setupCallbacks();
  this.stream.load(request);
};


/**
 *  Cancels the URL request.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.7.0
 */
org.apache.royale.net.URLBinaryLoader.prototype.close = function() {
  this.stream.close();
  this.cleanupCallbacks();
};


/**
 * Returns the string value of a specific response header.
 * The header name is case-insensitive.
 * 
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9.11
 * @param {string} name
 * @return {string}
 */
org.apache.royale.net.URLBinaryLoader.prototype.getResponseHeader = function(name) {
  return this.stream.getResponseHeader(name);
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
org.apache.royale.net.URLBinaryLoader.prototype.endian;


org.apache.royale.net.URLBinaryLoader.prototype.get__endian = function() {
  return this.org_apache_royale_net_URLBinaryLoader__endian;
};


org.apache.royale.net.URLBinaryLoader.prototype.set__endian = function(value) {
  this.org_apache_royale_net_URLBinaryLoader__endian = value;
};


Object.defineProperties(org.apache.royale.net.URLBinaryLoader.prototype, /** @lends {org.apache.royale.net.URLBinaryLoader.prototype} */ {
/**
 * @type {string}
 */
endian: {
get: org.apache.royale.net.URLBinaryLoader.prototype.get__endian,
set: org.apache.royale.net.URLBinaryLoader.prototype.set__endian}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.URLBinaryLoader.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'URLBinaryLoader', qName: 'org.apache.royale.net.URLBinaryLoader', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.URLBinaryLoader.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'data': { type: 'org.apache.royale.utils.BinaryData', get_set: function (/** org.apache.royale.net.URLBinaryLoader */ inst, /** * */ v) {return v !== undefined ? inst.data = v : inst.data;}},
        'bytesLoaded': { type: 'uint', get_set: function (/** org.apache.royale.net.URLBinaryLoader */ inst, /** * */ v) {return v !== undefined ? inst.bytesLoaded = v : inst.bytesLoaded;}},
        'bytesTotal': { type: 'uint', get_set: function (/** org.apache.royale.net.URLBinaryLoader */ inst, /** * */ v) {return v !== undefined ? inst.bytesTotal = v : inst.bytesTotal;}}
      };
    },
    accessors: function () {
      return {
        'endian': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.URLBinaryLoader'}
      };
    },
    methods: function () {
      return {
        'URLBinaryLoader': { type: '', declaredBy: 'org.apache.royale.net.URLBinaryLoader'},
        'load': { type: 'void', declaredBy: 'org.apache.royale.net.URLBinaryLoader', parameters: function () { return [ 'org.apache.royale.net.URLRequest', false ]; }},
        'close': { type: 'void', declaredBy: 'org.apache.royale.net.URLBinaryLoader'},
        'getResponseHeader': { type: 'String', declaredBy: 'org.apache.royale.net.URLBinaryLoader', parameters: function () { return [ 'String', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.net.URLBinaryLoader.prototype.ROYALE_COMPILE_FLAGS = 10;