/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/navigateToURL.as
 * org.apache.royale.net.navigateToURL
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.navigateToURL');
goog.provide('org.apache.royale.net.navigateToURL.doPostForm');

goog.require('org.apache.royale.net.HTTPConstants');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.net.URLVariables');
goog.require('org.apache.royale.utils.Language');



/**
 *  Opens or replaces a window in the application
 *
 *  @throws Error If the method is not called in response to a user action, such as a mouse event or keypress event.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @param {org.apache.royale.net.URLRequest} request
 * @param {string=} windowName
 */
org.apache.royale.net.navigateToURL = function(request, windowName) {
  windowName = typeof windowName !== 'undefined' ? windowName : null;
  var /** @type {string} */ url = request.url;
  var /** @type {boolean} */ needsPostSupport;
  if (request.data) {
    if (org.apache.royale.net.HTTPConstants.POST == request.method) {
      needsPostSupport = true;
    } else if (org.apache.royale.net.HTTPConstants.GET == request.method) {
      var /** @type {string} */ append = url.lastIndexOf('?') != -1 ? '&' : '?';
      url = url + append + request.data.toString();
    } else {
      throw new Error('unsupported request method in navigateToURL');
    }
  }
  var /** @type {Window} */ windowTarget = window.open(needsPostSupport ? "" : url, windowName);
  if (!windowTarget)
    throw new Error('navigateToURL requires interaction trigger');
  if (needsPostSupport) {
    windowName = org.apache.royale.utils.Language.string(windowTarget['name'] = 'window_' + Math.round((Math.random() * 100000)).toString(16));
    var /** @type {HTMLFormElement} */ submittedForm = org.apache.royale.net.navigateToURL.doPostForm(url, windowName, request.data, request.contentType, request.method);
    if (!submittedForm) {
      throw new Error('unsupported contentType in navigateToURL', request.contentType);
    }
    submittedForm.parentNode.removeChild(submittedForm);
  }
}


/**
 *
 * @royaleignorecoercion HTMLFormElement
 * @royaleignorecoercion HTMLInputElement
 * @param {string} url
 * @param {string} target
 * @param {Object} values
 * @param {string} encoding
 * @param {string} method
 * @return {HTMLFormElement}
 */
org.apache.royale.net.navigateToURL.doPostForm = function(url, target, values, encoding, method) {
  if (encoding == "application/json") {
    return null;
  } else if (encoding == "multipart/form-data") {
    return null;
  } else if (encoding == 'application/x-www-form-urlencoded') {
    if (org.apache.royale.utils.Language.is(values, String))
      values = new org.apache.royale.net.URLVariables(String(values));
  } else {
    return null;
  }
  var /** @type {HTMLFormElement} */ form = document.createElement('form');
  form.setAttribute('target', target);
  form.setAttribute('method', method);
  form.setAttribute('action', url);
  form.setAttribute('enctype', encoding);
  form.style.display = 'none';
  if (values) {
    var foreachiter0_target = Object.getOwnPropertyNames(values);
    for (var foreachiter0 in foreachiter0_target) 
    {
    var key = foreachiter0_target[foreachiter0];
    {
      var /** @type {HTMLInputElement} */ fakeField = document.createElement('input');
      fakeField.setAttribute('type', 'hidden');
      fakeField.setAttribute('name', key);
      fakeField.setAttribute('value', values[key]);
      form.appendChild(fakeField);
    }}
    
  }
  document.body.appendChild(form);
  form.submit();
  return form;
}