/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/utils/decodeQueryString.as
 * org.apache.royale.net.utils.decodeQueryString
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.utils.decodeQueryString');



/**
 *  Decode URL variables. 
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @param {string} queryString
 * @param {Object=} dest
 * @param {boolean=} stopAtError
 * @return {boolean}
 */
org.apache.royale.net.utils.decodeQueryString = function(queryString, dest, stopAtError) {
  dest = typeof dest !== 'undefined' ? dest : null;
  stopAtError = typeof stopAtError !== 'undefined' ? stopAtError : true;
  if (!dest)
    dest = {};
  if (!queryString || !queryString.length)
    return !!(dest);
  var /** @type {Array} */ pairs = queryString.split('&');
  var /** @type {number} */ l = (pairs.length) >>> 0;
  var /** @type {boolean} */ hadErrors;
  for (var /** @type {number} */ i = 0; i < l; i++) {
    var /** @type {Array} */ pair = String(pairs[i]).split('=');
    if (pair.length == 1) {
      hadErrors = true;
      if (stopAtError) {
        break;
      } else {
        continue;
      }
    }
    var /** @type {string} */ field = decodeURIComponent(org.apache.royale.utils.Language.string(pair[0]));
    var /** @type {string} */ value = org.apache.royale.utils.Language.string(pair[1]);
    value = decodeURIComponent(value.replace(/\+/g, '%20'));
    dest[field] = value;
  }
  return !hadErrors;
}