/**
 * Generated by Apache Royale Compiler from org/apache/royale/utils/async/HttpDownloadTask.as
 * org.apache.royale.utils.async.HttpDownloadTask
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.utils.async.HttpDownloadTask');

goog.require('org.apache.royale.events.ProgressEvent');
goog.require('org.apache.royale.utils.async.HttpRequestTask');
goog.require('org.apache.royale.utils.async.IAsyncTask');
goog.require('org.apache.royale.utils.Language');



/**
 * HttpDownloadTask is a HttpRequestTask which has download progress.
 * It is a basic request and not appropriate for a Multipart upload.
 * @constructor
 * @extends {org.apache.royale.utils.async.HttpRequestTask}
 */
org.apache.royale.utils.async.HttpDownloadTask = function() {
  org.apache.royale.utils.async.HttpDownloadTask.base(this, 'constructor');
};
goog.inherits(org.apache.royale.utils.async.HttpDownloadTask, org.apache.royale.utils.async.HttpRequestTask);


/**
 * @private
 * @type {number}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.org_apache_royale_utils_async_HttpDownloadTask__bytesLoaded = 0;


/**
 * @private
 * @type {number}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.org_apache_royale_utils_async_HttpDownloadTask__bytesTotal = 0;


/**
 * @protected
 * @override
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.attachLoaderCallbacks = function() {
  org.apache.royale.utils.async.HttpDownloadTask.superClass_.attachLoaderCallbacks.apply(this);
  this.loader.onProgress = org.apache.royale.utils.Language.closure(this.org_apache_royale_utils_async_HttpDownloadTask_onProgress, this, 'org_apache_royale_utils_async_HttpDownloadTask_onProgress');
};


/**
 * @private
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.org_apache_royale_utils_async_HttpDownloadTask_onProgress = function() {
  this.org_apache_royale_utils_async_HttpDownloadTask__bytesLoaded = (this.loader.bytesLoaded) >> 0;
  this.org_apache_royale_utils_async_HttpDownloadTask__bytesTotal = (this.loader.bytesTotal) >> 0;
  this.dispatchEvent(new org.apache.royale.events.ProgressEvent("progress", false, false, this.bytesLoaded, this.bytesTotal));
  if (this.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks) {
    for (var /** @type {number} */ i = 0; i < this.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks.length; i++) {
      this.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks[i](this);
    }
  }
};


/**
 * @private
 * @type {Array}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks;


/**
 * @param {Function} callback
 * @return {org.apache.royale.utils.async.IAsyncTask}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.progress = function(callback) {
  if (!this.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks) {
    this.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks = [];
  }
  this.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks.push(callback);
  return this;
};


/**
 * @protected
 * @override
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.destroy = function() {
  org.apache.royale.utils.async.HttpDownloadTask.superClass_.destroy.apply(this);
  this.org_apache_royale_utils_async_HttpDownloadTask_progressCallbacks = null;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.bytesLoaded;


org.apache.royale.utils.async.HttpDownloadTask.prototype.get__bytesLoaded = function() {
  return this.org_apache_royale_utils_async_HttpDownloadTask__bytesLoaded;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.bytesTotal;


org.apache.royale.utils.async.HttpDownloadTask.prototype.get__bytesTotal = function() {
  return this.org_apache_royale_utils_async_HttpDownloadTask__bytesTotal;
};


Object.defineProperties(org.apache.royale.utils.async.HttpDownloadTask.prototype, /** @lends {org.apache.royale.utils.async.HttpDownloadTask.prototype} */ {
/**
 * @type {number}
 */
bytesLoaded: {
get: org.apache.royale.utils.async.HttpDownloadTask.prototype.get__bytesLoaded},
/**
 * @type {number}
 */
bytesTotal: {
get: org.apache.royale.utils.async.HttpDownloadTask.prototype.get__bytesTotal}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HttpDownloadTask', qName: 'org.apache.royale.utils.async.HttpDownloadTask', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'bytesLoaded': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpDownloadTask'},
        'bytesTotal': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpDownloadTask'}
      };
    },
    methods: function () {
      return {
        'HttpDownloadTask': { type: '', declaredBy: 'org.apache.royale.utils.async.HttpDownloadTask'},
        'progress': { type: 'org.apache.royale.utils.async.IAsyncTask', declaredBy: 'org.apache.royale.utils.async.HttpDownloadTask', parameters: function () { return [ 'Function', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.utils.async.HttpDownloadTask.prototype.ROYALE_COMPILE_FLAGS = 10;