/**
 * Generated by Apache Royale Compiler from org/apache/royale/utils/async/HttpRequestTask.as
 * org.apache.royale.utils.async.HttpRequestTask
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.utils.async.HttpRequestTask');

goog.require('org.apache.royale.debugging.assert');
goog.require('org.apache.royale.net.HTTPConstants');
goog.require('org.apache.royale.net.URLBinaryLoader');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.utils.BinaryData');
goog.require('org.apache.royale.utils.async.AsyncTask');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.utils.async.AsyncTask}
 */
org.apache.royale.utils.async.HttpRequestTask = function() {
  
  this.contentType = org.apache.royale.net.HTTPConstants.FORM_URL_ENCODED;
  this.method = org.apache.royale.net.HTTPConstants.GET;
  org.apache.royale.utils.async.HttpRequestTask.base(this, 'constructor');
};
goog.inherits(org.apache.royale.utils.async.HttpRequestTask, org.apache.royale.utils.async.AsyncTask);


/**
 * @override
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.run = function(data) {
  data = typeof data !== 'undefined' ? data : null;
  org.apache.royale.debugging.assert(this.url != null, "url must be specified!");
  var /** @type {org.apache.royale.net.URLRequest} */ request = new org.apache.royale.net.URLRequest(this.url);
  request.contentType = this.contentType;
  request.method = this.method;
  if (this.requestHeaders)
    request.requestHeaders = this.requestHeaders;
  if (this.parameters)
    request.data = this.parameters;
  this.loader = this.getLoader();
  this.attachLoaderCallbacks();
  this.loader.load(request);
};


/**
 * @type {string}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.contentType;


/**
 * @type {string}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.method;


/**
 * @type {string}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.url;


/**
 * @type {Array}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.requestHeaders;


/**
 * @type {Object}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.parameters;


/**
 * @protected
 * @type {org.apache.royale.net.URLBinaryLoader}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.loader;


/**
 * Convenience function to access the underlying loader.
 * Should not usually be necessary since the result can be accessed directly from the task.
 * @return {org.apache.royale.net.URLBinaryLoader}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.getLoader = function() {
  if (!this.loader)
    this.loader = this.createLoader();
  return this.loader;
};


/**
 * Can be overridded in a subclass to use a different implementation (such as URLBinaryUploader)
 * @protected
 * @return {org.apache.royale.net.URLBinaryLoader}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.createLoader = function() {
  return new org.apache.royale.net.URLBinaryLoader();
};


/**
 * Can be overridden in a subclass
 * @protected
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.attachLoaderCallbacks = function() {
  this.loader.onComplete = org.apache.royale.utils.Language.closure(this.onComplete, this, 'onComplete');
  this.loader.onError = org.apache.royale.utils.Language.closure(this.onError, this, 'onError');
};


/**
 * Can be overridden in a subclass
 * @protected
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.onComplete = function() {
  this.complete();
};


/**
 * Can be overridden in a subclass
 * @protected
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.onError = function() {
  this.fail();
};


/**
 * @nocollapse
 * @param {string} url
 * @param {Function} callback
 * @param {string=} method
 * @param {Object=} parameters
 * @param {string=} contentType
 * @param {Array=} requestHeaders
 */
org.apache.royale.utils.async.HttpRequestTask.execute = function(url, callback, method, parameters, contentType, requestHeaders) {
  method = typeof method !== 'undefined' ? method : org.apache.royale.net.HTTPConstants.GET;
  parameters = typeof parameters !== 'undefined' ? parameters : null;
  contentType = typeof contentType !== 'undefined' ? contentType : org.apache.royale.net.HTTPConstants.FORM_URL_ENCODED;
  requestHeaders = typeof requestHeaders !== 'undefined' ? requestHeaders : null;
  var /** @type {org.apache.royale.utils.async.HttpRequestTask} */ task = new org.apache.royale.utils.async.HttpRequestTask();
  task.url = url;
  task.contentType = contentType;
  task.method = method;
  task.requestHeaders = requestHeaders;
  task.parameters = parameters;
  task.done(callback);
  task.run();
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.resultString;


org.apache.royale.utils.async.HttpRequestTask.prototype.get__resultString = function() {
  var /** @type {org.apache.royale.net.URLBinaryLoader} */ l = this.loader;
  if (l && l.data) {
    return l.data.readUTFBytes((l.data.length) >>> 0);
  }
  return "";
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.httpResult;


org.apache.royale.utils.async.HttpRequestTask.prototype.get__httpResult = function() {
  var /** @type {string} */ resultStr = this.resultString;
  try {
    return JSON.parse(resultStr);
  } catch (err) {
    return resultStr;
  }
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.httpStatus;


org.apache.royale.utils.async.HttpRequestTask.prototype.get__httpStatus = function() {
  if (this.loader) {
    return this.loader.requestStatus;
  }
  return 0;
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.utils.BinaryData}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.binaryResult;


org.apache.royale.utils.async.HttpRequestTask.prototype.get__binaryResult = function() {
  return this.loader ? this.loader.data : null;
};


Object.defineProperties(org.apache.royale.utils.async.HttpRequestTask.prototype, /** @lends {org.apache.royale.utils.async.HttpRequestTask.prototype} */ {
/**
 * @type {string}
 */
resultString: {
get: org.apache.royale.utils.async.HttpRequestTask.prototype.get__resultString},
/**
 * @type {Object}
 */
httpResult: {
get: org.apache.royale.utils.async.HttpRequestTask.prototype.get__httpResult},
/**
 * @type {number}
 */
httpStatus: {
get: org.apache.royale.utils.async.HttpRequestTask.prototype.get__httpStatus},
/**
 * @type {org.apache.royale.utils.BinaryData}
 */
binaryResult: {
get: org.apache.royale.utils.async.HttpRequestTask.prototype.get__binaryResult}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HttpRequestTask', qName: 'org.apache.royale.utils.async.HttpRequestTask', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'contentType': { type: 'String', get_set: function (/** org.apache.royale.utils.async.HttpRequestTask */ inst, /** * */ v) {return v !== undefined ? inst.contentType = v : inst.contentType;}},
        'method': { type: 'String', get_set: function (/** org.apache.royale.utils.async.HttpRequestTask */ inst, /** * */ v) {return v !== undefined ? inst.method = v : inst.method;}},
        'url': { type: 'String', get_set: function (/** org.apache.royale.utils.async.HttpRequestTask */ inst, /** * */ v) {return v !== undefined ? inst.url = v : inst.url;}},
        'requestHeaders': { type: 'Array', get_set: function (/** org.apache.royale.utils.async.HttpRequestTask */ inst, /** * */ v) {return v !== undefined ? inst.requestHeaders = v : inst.requestHeaders;}},
        'parameters': { type: 'Object', get_set: function (/** org.apache.royale.utils.async.HttpRequestTask */ inst, /** * */ v) {return v !== undefined ? inst.parameters = v : inst.parameters;}}
      };
    },
    accessors: function () {
      return {
        'resultString': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask'},
        'httpResult': { type: 'Object', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask'},
        'httpStatus': { type: 'Number', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask'},
        'binaryResult': { type: 'org.apache.royale.utils.BinaryData', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask'}
      };
    },
    methods: function () {
      return {
        'HttpRequestTask': { type: '', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask'},
        'run': { type: 'void', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask', parameters: function () { return [ 'Object', true ]; }},
        'getLoader': { type: 'org.apache.royale.net.URLBinaryLoader', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask'},
        '|execute': { type: 'void', declaredBy: 'org.apache.royale.utils.async.HttpRequestTask', parameters: function () { return [ 'String', false ,'Function', false ,'String', true ,'Object', true ,'String', true ,'Array', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.utils.async.HttpRequestTask.prototype.ROYALE_COMPILE_FLAGS = 10;