/**
 * Generated by Apache Royale Compiler from org/apache/royale/utils/async/HttpUploadTask.as
 * org.apache.royale.utils.async.HttpUploadTask
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.utils.async.HttpUploadTask');

goog.require('org.apache.royale.events.ProgressEvent');
goog.require('org.apache.royale.net.URLBinaryLoader');
goog.require('org.apache.royale.net.URLBinaryUploader');
goog.require('org.apache.royale.utils.async.HttpRequestTask');
goog.require('org.apache.royale.utils.async.IAsyncTask');
goog.require('org.apache.royale.utils.Language');



/**
 * HttpUploadTask is a HttpRequestTask which has upload progress.
 * It is a basic request and not appropriate for a Multipart upload.
 * 
 * HttpUploadTask uses URLBinaryUploader
 * Care should be taken when using this class because it attaches a progress listener to the xhr.upload object.
 * Doing so causes browsers to send OPTIONS requests. This will return an unauthorized response from servers not
 * configured to allow CORS OPTIONS requests. See this S.O. post for details. https://stackoverflow.com/a/17057853
 * 
 * progress can be listened to by one of the following:
 * 1. Specifying a progress(callback)
 * 2. attaching an event listener for ProgressEvent.PROGRESS
 * 
 * @constructor
 * @extends {org.apache.royale.utils.async.HttpRequestTask}
 */
org.apache.royale.utils.async.HttpUploadTask = function() {
  org.apache.royale.utils.async.HttpUploadTask.base(this, 'constructor');
};
goog.inherits(org.apache.royale.utils.async.HttpUploadTask, org.apache.royale.utils.async.HttpRequestTask);


/**
 * @private
 * @type {number}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.org_apache_royale_utils_async_HttpUploadTask__bytesLoaded = 0;


/**
 * @private
 * @type {number}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.org_apache_royale_utils_async_HttpUploadTask__bytesTotal = 0;


/**
 * @protected
 * @override
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.createLoader = function() {
  return new org.apache.royale.net.URLBinaryUploader();
};


/**
 * @protected
 * @override
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.attachLoaderCallbacks = function() {
  org.apache.royale.utils.async.HttpUploadTask.superClass_.attachLoaderCallbacks.apply(this);
  org.apache.royale.utils.Language.as(this.loader, org.apache.royale.net.URLBinaryUploader).onUploadProgress = org.apache.royale.utils.Language.closure(this.org_apache_royale_utils_async_HttpUploadTask_onProgress, this, 'org_apache_royale_utils_async_HttpUploadTask_onProgress');
};


/**
 * @private
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.org_apache_royale_utils_async_HttpUploadTask_onProgress = function() {
  this.org_apache_royale_utils_async_HttpUploadTask__bytesLoaded = (this.loader.bytesLoaded) >> 0;
  this.org_apache_royale_utils_async_HttpUploadTask__bytesTotal = (this.loader.bytesTotal) >> 0;
  this.dispatchEvent(new org.apache.royale.events.ProgressEvent("progress", false, false, this.bytesLoaded, this.bytesTotal));
  if (this.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks) {
    for (var /** @type {number} */ i = 0; i < this.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks.length; i++) {
      this.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks[i](this);
    }
  }
};


/**
 * @private
 * @type {Array}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks;


/**
 * @param {Function} callback
 * @return {org.apache.royale.utils.async.IAsyncTask}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.progress = function(callback) {
  if (!this.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks) {
    this.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks = [];
  }
  this.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks.push(callback);
  return this;
};


/**
 * @protected
 * @override
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.destroy = function() {
  org.apache.royale.utils.async.HttpUploadTask.superClass_.destroy.apply(this);
  this.org_apache_royale_utils_async_HttpUploadTask_progressCallbacks = null;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.bytesLoaded;


org.apache.royale.utils.async.HttpUploadTask.prototype.get__bytesLoaded = function() {
  return this.org_apache_royale_utils_async_HttpUploadTask__bytesLoaded;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.bytesTotal;


org.apache.royale.utils.async.HttpUploadTask.prototype.get__bytesTotal = function() {
  return this.org_apache_royale_utils_async_HttpUploadTask__bytesTotal;
};


Object.defineProperties(org.apache.royale.utils.async.HttpUploadTask.prototype, /** @lends {org.apache.royale.utils.async.HttpUploadTask.prototype} */ {
/**
 * @type {number}
 */
bytesLoaded: {
get: org.apache.royale.utils.async.HttpUploadTask.prototype.get__bytesLoaded},
/**
 * @type {number}
 */
bytesTotal: {
get: org.apache.royale.utils.async.HttpUploadTask.prototype.get__bytesTotal}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HttpUploadTask', qName: 'org.apache.royale.utils.async.HttpUploadTask', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'bytesLoaded': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpUploadTask'},
        'bytesTotal': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.utils.async.HttpUploadTask'}
      };
    },
    methods: function () {
      return {
        'HttpUploadTask': { type: '', declaredBy: 'org.apache.royale.utils.async.HttpUploadTask'},
        'progress': { type: 'org.apache.royale.utils.async.IAsyncTask', declaredBy: 'org.apache.royale.utils.async.HttpUploadTask', parameters: function () { return [ 'Function', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.utils.async.HttpUploadTask.prototype.ROYALE_COMPILE_FLAGS = 10;